# defines build release
%define TSL_release yes

# defines using extended licensing
%define use_ctlicense yes

# defines PAM authentication
%if "%{TSL_release}" == "yes"
%define no_use_pamauth 0
%else
%define no_use_pamauth 1
%endif

# turns build checklic script on
# %define build_checklic no

Summary: remote administration of dedicated servers
Name: cpplus
Version: 3.4.1
Release: 1tr
License: commercial
Group: Trustix Commercial
URL: http://cpplus.info
Vendor: Positive Software Corporation

Source0: %{name}-%{version}.tar.gz

BuildArch: i586
AutoReq: 0

BuildRequires: perl, openssl
%if "%{use_ctlicense}" == "yes"
BuildRequires: expat-devel, openssl-devel
%endif

Requires: perl >= 5.002, gnupg, openssl, chkconfig
%if "%{TSL_release}" == "yes"
Requires: perl-net-ssleay, perl-authen-pam
Requires: perl-dbd-mysql, perl-dbd-pg
%endif

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-%(id -nu)/

%define install_prefix /usr
%define product_dir %{install_prefix}/%{name}
%define product_dir_eu %{product_dir}/enduser_cp
%define services_dir %{_sysconfdir}/init.d

%define config_dir %{_sysconfdir}/%{name}
%define var_dir %{_localstatedir}/%{name}
%define config_dir_eu %{config_dir}/enduser_cp
%define var_dir_eu %{var_dir}/enduser_cp
%define tmp_config_dir %{buildroot}%{config_dir}
%define tmp_var_dir %{buildroot}%{var_dir}
%define tmp_config_dir_eu %{buildroot}%{config_dir_eu}
%define tmp_var_dir_eu %{buildroot}%{var_dir_eu}

%define licmanagedir licmanage
%define ctlicensedir %{licmanagedir}/ctlicense

# disable debug info
%define debug_package %{nil}

%description
CP+ is a web-based tool for remote administration of dedicated servers.
It can be used to perform basic administrative tasks and create/manage domains through a graphical interface, which makes system administration easy and comfortable. Users don't need to remember a long list of console commands with complex syntax and valid parameter values.
All major system management tasks are now presented as icons providing a single entry point from which to perform a task.

%prep

%setup -q

(find . -name '*.cgi' -print ; find . -name '*.pl' -print) | %{__perl} "./perlpath.pl" %{__perl} -

%{__rm} -f mount/freebsd-mounts* mount/openbsd-mounts* mount/macos-mounts* cpplus-gentoo-init
%{__rm} -f {,config-}{aix,corel,cygwin,debian,freebsd,gentoo,hpux,irix,lfs,macos,mandrake,msc,netbsd,open,openbsd,openserver,osf1,slackware,suse,turbo,united,unixware,solaris}{,-*}

%build
# %if "%{use_ctlicense}" == "yes"
# Builds extended license checker
# pushd %{ctlicensedir}
# make clean
# make
# popd
# %endif

%install

[ -n "%{buildroot}" -a "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

# installing and updating cpplus root files
%{__install} -d -m0755 %{buildroot}%{product_dir}
%{__cp} -a * %{buildroot}%{product_dir}

%{__install} -D -m0644 cpplus-daemon %{buildroot}%{_sysconfdir}/sysconfig/daemons/%{name}
%{__install} -D -m0755 cpplus-init %{buildroot}%{services_dir}/%{name}
%{__install} -D -m0644 cpplus-pam %{buildroot}%{_sysconfdir}/pam.d/%{name}

# %if "%{use_ctlicense}" == "yes"
# Installs extended license checker
# pushd %{buildroot}%{product_dir}
# if [ -f "%{ctlicensedir}/checklic" ]; then
# 	%{__rm} -f  %{licmanagedir}/checklic*
# 	%{__cp} -fa %{ctlicensedir}/checklic %{licmanagedir}
# fi
# %{__rm} -rf %{ctlicensedir}
# popd
# %endif

echo "rpm" > %{buildroot}%{product_dir}/install-type

# theme name
theme_name="theme_xpressia"

# detecting OS
%{__perl} "%{buildroot}%{product_dir}/oschooser.pl" "%{buildroot}%{product_dir}/os_list.txt" %{_tmppath}/$$.os 2
. %{_tmppath}/$$.os
%{__rm} -f %{_tmppath}/$$.os

# finding all cp+ and enduser cp+ modules
allmods=`echo */module.info | sed -e 's/\/module.info//g'`
allmods_eu=`cd "./enduser_cp"; echo */module.info | sed -e 's/\/module.info//g'`
if [ "$allmods" = "" -o "$allmods_eu" = "" ]; then
	echo "ERROR: Failed to get CP+ modules list"
	echo ""
	exit 1
fi

# creating modules' config files
%{__perl} "%{buildroot}%{product_dir}/copyconfig.pl" "$os_type" "$os_version" "%{buildroot}%{product_dir}" %{tmp_config_dir} "" $allmods
%{__perl} "%{buildroot}%{product_dir_eu}/copyconfig.pl" "$os_type" "$os_version" "%{buildroot}%{product_dir_eu}" %{tmp_config_dir_eu} "" $allmods_eu

# creating /var/cpplus & /var/cpplus/enduser_cp
#%{__mkdir_p} %{tmp_config_dir}
#%{__mkdir_p} %{tmp_config_dir_eu}

# adding os info for CP+
echo "os_type=$os_type" >> %{tmp_config_dir}/config
echo "os_version=$os_version" >> %{tmp_config_dir}/config
echo "real_os_type=$real_os_type" >> %{tmp_config_dir}/config
echo "real_os_version=$real_os_version" >> %{tmp_config_dir}/config

# adding os info for EndUser CP+
echo "os_type=$os_type" >> %{tmp_config_dir_eu}/config
echo "os_version=$os_version" >> %{tmp_config_dir_eu}/config
echo "real_os_type=$real_os_type" >> %{tmp_config_dir_eu}/config
echo "real_os_version=$real_os_version" >> %{tmp_config_dir_eu}/config

# creating /var/cpplus & /var/cpplus/enduser_cp
%{__mkdir_p} %{tmp_var_dir}
%{__mkdir_p} %{tmp_var_dir_eu}

# creating path-files
echo "%{__perl}" > %{tmp_config_dir}/perl-path
echo "%{var_dir}" > %{tmp_config_dir}/var-path
echo "%{__perl}" > %{tmp_config_dir_eu}/perl-path
echo "%{var_dir_eu}" > %{tmp_config_dir_eu}/var-path

# creating webserver config files (miniserv.conf)
	cfile=%{tmp_config_dir}/miniserv.conf
	cfile_cpp=$cfile
	echo "port=10000" >> $cfile
	echo "root=%{product_dir}" >> $cfile
	echo "unauth=/gfx_login/" >> $cfile
	echo "mimetypes=%{product_dir}/mime.types" >> $cfile
	echo "addtype_cgi=internal/cgi" >> $cfile
	echo "realm=CP+ Server" >> $cfile
	echo "logfile=%{var_dir}/miniserv.log" >> $cfile
	echo "errorlog=%{var_dir}/miniserv.error" >> $cfile
	echo "pidfile=%{var_dir}/miniserv.pid" >> $cfile
	echo "logtime=168" >> $cfile
	echo "ppath=" >> $cfile
	echo "ssl=1" >> $cfile
	echo "env_WEBMIN_CONFIG=%{config_dir}" >> $cfile
	echo "env_WEBMIN_VAR=%{var_dir}" >> $cfile
	echo "atboot=1" >> $cfile
	echo "logout=%{config_dir}/logout-flag" >> $cfile
	echo "listen=10000" >> $cfile
	echo "denyfile=\\.pl\$" >> $cfile
	echo "log=1" >> $cfile
	echo "blockhost_failures=5" >> $cfile
	echo "blockhost_time=60" >> $cfile
	echo "syslog=1" >> $cfile
	echo "session=1" >> $cfile
	echo "pam=cpplus" >> $cfile
	echo "no_pam=%{no_use_pamauth}" >> $cfile
	echo "passdelay=1" >> $cfile
	echo "keyfile=%{config_dir}/miniserv.pem" >> $cfile

# creating cp+ miniserv.users
#md5pass=`%{__perl} -e 'print crypt("test", "\\$1\\$A9wB3O18\\$zaZgqrEmb9VNltWTL454R/") eq "\\$1\\$A9wB3O18\\$zaZgqrEmb9VNltWTL454R/" ? "1\n" : "0\n"'`

ufile=%{tmp_config_dir}/miniserv.users
touch $ufile
login=admin
#password=admin
#if [ "$md5pass" = "1" ]; then
#	%{__perl} -e 'print "$ARGV[0]:",crypt($ARGV[1], "\$1\$XXXXXXXX"),":0\n"' "$login" "$password" > $ufile
#else
#	%{__perl} -e 'print "$ARGV[0]:",crypt($ARGV[1], "XX"),":0\n"' "$login" "$password" > $ufile
#fi
echo "userfile=%{config_dir}/miniserv.users" >> $cfile_cpp

# create CP+ enduser_cp/miniserv.conf
cfile=%{tmp_config_dir_eu}/miniserv.conf
cfile_eu=$cfile
	echo "port=20000" >> $cfile
	echo "root=%{product_dir_eu}" >> $cfile
	echo "unauth=/gfx_login/" >> $cfile
	echo "mimetypes=%{product_dir_eu}/mime.types" >> $cfile
	echo "addtype_cgi=internal/cgi" >> $cfile
	echo "realm=EndUser CP+ Server" >> $cfile
	echo "logfile=%{var_dir_eu}/miniserv.log" >> $cfile
	echo "errorlog=%{var_dir_eu}/miniserv.error" >> $cfile
	echo "pidfile=%{var_dir_eu}/miniserv.pid" >> $cfile
	echo "logtime=168" >> $cfile
	echo "ppath=" >> $cfile
	echo "ssl=1" >> $cfile
	echo "env_WEBMIN_CONFIG=%{config_dir_eu}" >> $cfile
	echo "env_WEBMIN_VAR=%{var_dir_eu}" >> $cfile
	echo "atboot=1" >> $cfile
	echo "logout=%{config_dir_eu}/logout-flag" >> $cfile
	echo "listen=20000" >> $cfile
	echo "denyfile=\\.pl\$" >> $cfile
	echo "log=1" >> $cfile
	echo "blockhost_failures=5" >> $cfile
	echo "blockhost_time=60" >> $cfile
	echo "session=1" >> $cfile
	echo "unixauth=user" >> $cfile
	#echo "localauth=1" >> $cfile
	echo "pam=cpplus" >> $cfile
	echo "no_pam=%{no_use_pamauth}" >> $cfile
	echo "passdelay=1" >> $cfile
	#echo "denyusers=root" >> $cfile
	echo "keyfile=%{config_dir_eu}/miniserv.pem" >> $cfile

# enduser cp miniserv.users
ufile=%{tmp_config_dir_eu}/miniserv.users
ufile_eu=$ufile
echo "user:x:0::" > $ufile
echo "userfile=%{config_dir_eu}/miniserv.users" >> $cfile_eu

# creating cp+ cpplus.acl file
afile=%{tmp_config_dir}/cpplus.acl
rm -f $afile
echo "$login: $allmods" >> $afile

# creating enduser cp+ cpplus.acl file
afile=%{tmp_config_dir_eu}/cpplus.acl
rm -f $afile
echo "user: $allmods_eu" >> $afile

# -----------------
# creating CP+ start script
rm -f %{tmp_config_dir}/stop %{tmp_config_dir}/start %{tmp_config_dir}/restart
echo "#!/bin/sh" >>%{tmp_config_dir}/start
echo "echo Starting CP+ server in %{product_dir}" >>%{tmp_config_dir}/start
echo "trap '' 1" >>%{tmp_config_dir}/start
echo "LANG=" >>%{tmp_config_dir}/start
echo "export LANG" >>%{tmp_config_dir}/start
echo "#PERLIO=:raw" >>%{tmp_config_dir}/start
echo "unset PERLIO" >>%{tmp_config_dir}/start
echo "export PERLIO" >>%{tmp_config_dir}/start

echo "if [ -e \"%{config_dir}/firststart-flag\" ]; then" >>%{tmp_config_dir}/start
echo "    %{product_dir}/adminpass.pl \"%{config_dir}\" >/dev/null 2>&1" >>%{tmp_config_dir}/start
echo "    rm -f \"%{config_dir}/firststart-flag\"" >>%{tmp_config_dir}/start
echo "fi" >>%{tmp_config_dir}/start

# commands for starting CP+ Server
echo "PERLLIB=%{product_dir}" >>%{tmp_config_dir}/start
echo "export PERLLIB" >>%{tmp_config_dir}/start
echo "\`%{product_dir}/miniserv.pl \"%{config_dir}/miniserv.conf\" &\`" >>%{tmp_config_dir}/start

# commands for starting EndUser CP+ Server
echo "PERLLIB=%{product_dir_eu}" >>%{tmp_config_dir}/start
echo "export PERLLIB" >>%{tmp_config_dir}/start
echo "\`%{product_dir_eu}/miniserv.pl \"%{config_dir_eu}/miniserv.conf\" &\`" >>%{tmp_config_dir}/start

# creating CP+ stop script
echo "#!/bin/sh" >>%{tmp_config_dir}/stop
echo "echo Stopping CP+ server in %{product_dir}" >>%{tmp_config_dir}/stop
echo "pidfile=\`grep \"^pidfile=\" %{config_dir}/miniserv.conf | sed -e 's/pidfile=//g'\`" >>%{tmp_config_dir}/stop
echo "kill \`cat \$pidfile\`" >>%{tmp_config_dir}/stop
echo "pidfile=\`grep \"^pidfile=\" %{config_dir_eu}/miniserv.conf | sed -e 's/pidfile=//g'\`" >>%{tmp_config_dir}/stop
echo "kill \`cat \$pidfile\` " >>%{tmp_config_dir}/stop

# creating CP+ restart script
echo "#!/bin/sh" >>%{tmp_config_dir}/restart
echo "%{config_dir}/stop && %{config_dir}/start" >>%{tmp_config_dir}/restart
# -------------------------

# setting additional cp+ options
echo "log=1" >> %{tmp_config_dir}/config
if [ "$md5pass" = "1" ]; then
	echo md5pass=1 >> %{tmp_config_dir}/config
fi
echo "product=cpplus" >> %{tmp_config_dir}/config

# setting additional enduser cp options
echo "userconfig=.enduser_cp" >> %{tmp_config_dir_eu}/config
echo "overlang=ulang" >> %{tmp_config_dir_eu}/config
echo "nofeedbackcc=2" >> %{tmp_config_dir_eu}/config
echo "nofeedbackconf=1" >> %{tmp_config_dir_eu}/config
echo "product=enduser_cp" >> %{tmp_config_dir_eu}/config

# adding theme name
echo "theme=$theme_name" >> %{tmp_config_dir}/config
echo "preroot=$theme_name" >> %{tmp_config_dir}/miniserv.conf
echo "theme=$theme_name" >> %{tmp_config_dir_eu}/config
echo "preroot=$theme_name" >> %{tmp_config_dir_eu}/miniserv.conf

# writing product version
echo "%{version}" > %{tmp_config_dir}/version
echo "%{version}" > %{tmp_config_dir_eu}/version

### Clean up buildroot
%{__perl} -pi -e 's|%{buildroot}||g' %{tmp_config_dir}/{miniserv.conf,restart,start,stop}
%{__rm} -f %{buildroot}%{product_dir}/{LICENCE*,README*,setup.sh,miniserv.pem}

#%{__perl} -pi -e 's|%{buildroot}||g' %{buildroot}%{_sysconfdir}/%{product_name}/enduser_cp/miniserv.conf
%{__rm} -f %{buildroot}%{product_dir}/enduser_cp/{LICENCE*,README*,setup.sh,miniserv.pem}

echo "$allmods" > %{buildroot}%{product_dir}/allmods
echo "$allmods_eu" > %{buildroot}%{product_dir}/enduser_cp/allmods

# getting list of all cp+ files and directories
pushd %{buildroot}
#find . -type d | grep -v '%{product_dir}' > %{_tmppath}/$$.dirs
#find . -type d | grep '%{config_dir}' | grep '%{var_dir}' > %{_tmppath}/$$.dirs
#find . -type d | grep -v '%{product_dir}' | grep -v '%{services_dir}' | grep -v '%{_sysconfdir}/pam.d' | grep -v '%{_sysconfdir}/init.d' | grep -v '%{_sysconfdir}/sysconfig' > %{_tmppath}/$$.dirs
find . -type d | grep -v '%{product_dir}' | grep -v '%{services_dir}' | grep -v '%{_sysconfdir}/pam.d' | grep -v '%{_sysconfdir}/sysconfig' > %{_tmppath}/$$.dirs
find . -type f | grep -v '%{product_dir}' | grep -v '%{config_dir}/\(start\|stop\|restart\)' > %{_tmppath}/$$.files
#find . -type f | grep '%{config_dir}' | grep '%{var_dir}' > %{_tmppath}/$$.files
popd

#find . -type d > %{_tmppath}/%{filelist_file}
perl -pi -e "s|^.||g" %{_tmppath}/$$.files %{_tmppath}/$$.dirs
perl -pi -e "s|^%{config_dir}|%config(noreplace) %{config_dir}|g" %{_tmppath}/$$.files
#perl -pi -e "s|^%{_sysconfdir}/pam.d/%{name}|%config %{_sysconfdir}/pam.d/%{name}|g" %{_tmppath}/$$.files
#perl -pi -e "s|^%{_sysconfdir}/sysconfig/%{name}|%config %{_sysconfdir}/sysconfig/%{name}|g" %{_tmppath}/$$.files
#echo "%config %{services_dir}/%{name}" >> %{_tmppath}/$$.files
echo "%{config_dir}/start" >> %{_tmppath}/$$.files
echo "%{config_dir}/stop" >> %{_tmppath}/$$.files
echo "%{config_dir}/restart" >> %{_tmppath}/$$.files

echo "%{product_dir}" >> %{_tmppath}/$$.files

#perl -pi -e "s|\*|\\\*|g" %{_tmppath}/$$.files

perl -pi -e "s|^/|%dir /|g" %{_tmppath}/$$.dirs

%{__rm} -f %{_tmppath}/product.filelist
cat %{_tmppath}/$$.files %{_tmppath}/$$.dirs >> %{_tmppath}/product.filelist

%pre
config_dir=%{config_dir}
config_dir_eu=%{config_dir_eu}
installedmods=
installedmods_eu=
[ -d "$config_dir" ] && installedmods=`cd "$config_dir"; echo */config | sed -e 's/\/config//g'`
[ -d "$config_dir_eu" ] && installedmods_eu=`cd "$config_dir_eu"; echo */config | sed -e 's/\/config//g'`
echo "$installedmods" > %{_tmppath}/.installedmods
echo "$installedmods_eu" > %{_tmppath}/.installedmods_eu

%post

wadir=%{product_dir}
config_dir=%{config_dir}
var_dir=%{var_dir}
wadir_eu=%{product_dir_eu}
config_dir_eu=%{config_dir_eu}
var_dir_eu=%{var_dir_eu}
theme_name=theme_xpressia
[ "$1" = "2" ] && upgrading=1;

# detecting OS
%{__perl} "$wadir/oschooser.pl" "$wadir/os_list.txt" %{_tmppath}/$$.os 2
. %{_tmppath}/$$.os
%{__rm} -f %{_tmppath}/$$.os

# change os info for CP+
grep -v "^os_type=" $config_dir/config | grep -v "^os_version=" | grep -v "^real_os_type=" | grep -v "^real_os_version=" >%{_tmppath}/$$.config
%{__mv} %{_tmppath}/$$.config $config_dir/config
echo "os_type=$os_type" >> $config_dir/config
echo "os_version=$os_version" >> $config_dir/config
echo "real_os_type=$real_os_type" >> $config_dir/config
echo "real_os_version=$real_os_version" >> $config_dir/config

# change os info for EndUser CP+
grep -v "^os_type=" $config_dir/enduser_cp/config | grep -v "^os_version=" | grep -v "^real_os_type=" | grep -v "^real_os_version=" >%{_tmppath}/$$.config
%{__mv} %{_tmppath}/$$.config $config_dir/enduser_cp/config
echo "os_type=$os_type" >> $config_dir/enduser_cp/config
echo "os_version=$os_version" >> $config_dir/enduser_cp/config
echo "real_os_type=$real_os_type" >> $config_dir/enduser_cp/config
echo "real_os_version=$real_os_version" >> $config_dir/enduser_cp/config

# detecting new modules and upgrade acl
allmods=`cat $wadir/allmods`
allmods_eu=`cat $wadir_eu/allmods`
%{__cp} -f "$wadir/neededmodules" "$config_dir/neededmodules"
%{__perl} "$wadir/newmods_rpm.pl" $config_dir %{_tmppath}/.installedmods $wadir/allmods
%{__cp} -f "$wadir_eu/neededmodules" "$config_dir_eu/neededmodules"
%{__perl} "$wadir/newmods_rpm.pl" $config_dir_eu %{_tmppath}/.installedmods_eu $wadir_eu/allmods

if [ "$upgrading" = "1" ]; then
	%{__perl} "$wadir/remdups.pl" "$wadir" $allmods
	%{__perl} "$wadir_eu/remdups.pl" "$wadir_eu" $allmods_eu

	# updating modules' config files
	for mod in `cat %{_tmppath}/.installedmods`
	do
	 mod2=`echo $mod | sed -e 's/-/_/g'`
	  if [ "$mod" != "$mod2" -a "`grep -e "$mod2" $wadir/allmods`" != "" ]; then
	  [ -d $config_dir/$mod2 ] && %{__rm} -rf $config_dir/$mod2
	  [ -d $config_dir/$mod ] && %{__mv} $config_dir/$mod $config_dir/$mod2
	  fi
	done

	%{__perl} "$wadir/copyconfig.pl" "$os_type" "$os_version" "$wadir" "$config_dir" "" $allmods
	%{__perl} "$wadir_eu/copyconfig.pl" "$os_type" "$os_version" "$wadir_eu" "$config_dir_eu" "" $allmods_eu

	# Update miniserv.conf with new root directory and mime types file
	grep -v "^root=" $config_dir/miniserv.conf | grep -v "^mimetypes=" >$tempdir/$$.miniserv.conf
	mv $tempdir/$$.miniserv.conf $config_dir/miniserv.conf
	echo "root=$wadir" >> $config_dir/miniserv.conf
	echo "mimetypes=$wadir/mime.types" >> $config_dir/miniserv.conf

	grep -v "^root=" $config_dir_eu/miniserv.conf | grep -v "^mimetypes=" >$tempdir/$$.miniserv.conf
	mv $tempdir/$$.miniserv.conf $config_dir_eu/miniserv.conf
	echo "root=$wadir_eu" >> $config_dir_eu/miniserv.conf
	echo "mimetypes=$wadir_eu/mime.types" >> $config_dir_eu/miniserv.conf
fi

# Create pem files
local_hostname=`cat /etc/sysconfig/network | grep -i '^hostname=' | sed -e 's/^hostname=//gi'`
echo -e ".\n.\n.\nCP+ Webserver on $local_hostname\n.\n*\nroot@$(hostname)" | \
openssl req -newkey rsa:512 -x509 -nodes -out %{_tmppath}/cert -keyout %{_tmppath}/key -days 1825 &>/dev/null
if [ $? -eq 0 ]; then
	PEMFILE="$config_dir/miniserv.pem"
	if [ -f "$PEMFILE" ]; then PEMFILE="$PEMFILE.rpmnew"; fi
	%{__cat} %{_tmppath}/cert %{_tmppath}/key >"$PEMFILE"
	%{__chmod} 0600 "$PEMFILE"
fi

echo -e ".\n.\n.\nEndUser CP+ Webserver on $local_hostname\n.\n*\nroot@$(hostname)" | \
openssl req -newkey rsa:512 -x509 -nodes -out %{_tmppath}/cert -keyout %{_tmppath}/key -days 1825 &>/dev/null
if [ $? -eq 0 ]; then
	PEMFILE="$config_dir_eu/miniserv.pem"
	if [ -f "$PEMFILE" ]; then PEMFILE="$PEMFILE.rpmnew"; fi
	%{__cat} %{_tmppath}/cert %{_tmppath}/key >"$PEMFILE"
	%{__chmod} 0600 "$PEMFILE"
fi

# Set passwd_ fields in miniserv.conf from global config for CP+
for field in passwd_file passwd_uindex passwd_pindex passwd_cindex passwd_mindex; do
	grep $field= $config_dir/miniserv.conf >/dev/null
	if [ "$?" != "0" ]; then
		grep $field= $config_dir/config >> $config_dir/miniserv.conf
	fi
done
grep passwd_mode= $config_dir/miniserv.conf >/dev/null
if [ "$?" != "0" ]; then
	echo passwd_mode=0 >> $config_dir/miniserv.conf
fi

# Set passwd_ fields in miniserv.conf from global config for EndUser CP+
	for field in passwd_file passwd_uindex passwd_pindex passwd_cindex passwd_mindex; do
		grep $field= $config_dir_eu/miniserv.conf >/dev/null
		if [ "$?" != "0" ]; then
			grep $field= $config_dir_eu/config >> $config_dir_eu/miniserv.conf
		fi
	done
	grep passwd_mode= $config_dir_eu/miniserv.conf >/dev/null
	if [ "$?" != "0" ]; then
		echo passwd_mode=2 >> $config_dir_eu/miniserv.conf
	fi
	# Set enduser_cp-specific SID cookie name
	grep sidname= $config_dir_eu/miniserv.conf >/dev/null
	if [ "$?" != "0" ]; then
		echo sidname=usid >> $config_dir_eu/miniserv.conf
	fi

# setting up root password for admin account
if [ "$upgrading" != "1" ]; then
	ufile=$config_dir/miniserv.users
	login=admin
	password=admin
	crypt=`%{__perl} -e '$pwd=(getpwuid($<))[1];print "$pwd\n";exit(0);'`
	if [ "$crypt" = "x" -o "$crypt" = "*" ]; then
		crypt=`cat /etc/shadow | grep "^root:" | awk 'BEGIN{FS=":"} {print $2}' 2>/dev/null`
	fi

	grep -v "^$login:" $ufile >%{_tmppath}/$$.users
	%{__mv} %{_tmppath}/$$.users $ufile
	if [ "$crypt" != "" ]; then
		echo "$login:$crypt:0" > $ufile
	else
	# checking md5 password
		md5pass=`%{__perl} -e 'print crypt("test", "\\$1\\$A9wB3O18\\$zaZgqrEmb9VNltWTL454R/") eq "\\$1\\$A9wB3O18\\$zaZgqrEmb9VNltWTL454R/" ? "1\n" : "0\n"'`
		if [ "$md5pass" = "1" ]; then
			%{__perl} -e 'print "$ARGV[0]:",crypt($ARGV[1], "\$1\$XXXXXXXX"),":0\n"' "$login" "$password" > $ufile
		else
			%{__perl} -e 'print "$ARGV[0]:",crypt($ARGV[1], "XX"),":0\n"' "$login" "$password" > $ufile
		fi
	fi

	# create file which indicates what
	echo "1" > $config_dir/firststart-flag
fi

# updating some $config_dir/miniserv.conf options
for field in passdelay pam; do
	grep -v "^$field=" $config_dir/miniserv.conf >%{_tmppath}/$$.miniserv.conf
	%{__mv} %{_tmppath}/$$.miniserv.conf $config_dir/miniserv.conf
done
echo "passdelay=1" >> $config_dir/miniserv.conf
echo "pam=cpplus" >> $config_dir/miniserv.conf

# updating some $config_dir/enduser_cp/miniserv.conf options
for field in passdelay pam; do
	grep -v "^$field=" $config_dir_eu/miniserv.conf >%{_tmppath}/$$.miniserv.conf
	%{__mv} %{_tmppath}/$$.miniserv.conf $config_dir_eu/miniserv.conf
done
echo "passdelay=1" >> $config_dir_eu/miniserv.conf
echo "pam=cpplus" >> $config_dir_eu/miniserv.conf

# configuring CP+ to start at boot time
#if [ "%{freevps}" != "1" ]; then
#	(cd "$wadir/init" ; WEBMIN_CONFIG=$config_dir WEBMIN_VAR=$var_dir "$wadir/init/atboot.pl" >/dev/null 2>&1)
#fi

# deleting unsupported modules
# (cd "$wadir" ; WEBMIN_CONFIG=$config_dir WEBMIN_VAR=$var_dir "$wadir/rm-unsupported.pl" >/dev/null 2>&1)

# running postinstall scripts
(cd "$wadir" ; WEBMIN_CONFIG=$config_dir WEBMIN_VAR=$var_dir WEBMIN_UPGRADE=$upgrading "$wadir/run-postinstalls.pl" >/dev/null 2>&1)
(cd "$wadir" ; %{__cp} ./$theme_name/cpplus.catnames "$config_dir")

# running EndUser CP+ postsetup script
# (cd "$wadir_eu" ; ./$theme_name/post_setup.pl "$config_dir")

# changing ownership and permissions
%{__chmod} 755 $config_dir/{start,stop,restart}
%{__chown} -R root:bin $config_dir
%{__chmod} -R og-rw $config_dir
%{__chmod} 755 $config_dir
%{__chmod} 755 $config_dir/{sendmail,qmailadmin,postfix}*/config >/dev/null 2>&1
%{__chmod} 755 $config_dir/{sendmail,qmailadmin,postfix}*/autoreply.pl >/dev/null 2>&1
%{__chmod} 755 $config_dir/{sendmail,qmailadmin,postfix}*/filter.pl >/dev/null 2>&1
%{__chmod} 755 $config_dir/squid*/squid-auth.pl >/dev/null 2>&1
%{__chmod} 755 $config_dir/squid*/users >/dev/null 2>&1
%{__chmod} +r $config_dir/version
%{__chown} -R root:bin $wadir
%{__chmod} -R og-w $wadir
%{__chmod} -R a+rx $wadir
%{__chown} -R root:bin $var_dir
%{__chmod} -R og-rwx $var_dir
%{__chmod} 600 $config_dir/miniserv.pem 2>/dev/null
# enduser_cp
%{__chown} -R root:bin $config_dir_eu
%{__chmod} -R 755 $config_dir_eu
%{__chown} -R root:bin $wadir_eu
%{__chmod} -R og-w $wadir_eu
%{__chown} -R root:bin $var_dir_eu
%{__chmod} -R og-w $var_dir_eu
%{__chmod} -R a+rx $wadir_eu
%{__chmod} 600 $config_dir_eu/miniserv.pem 2>/dev/null

(cd "$config_dir"; %{__chmod} 600 cpplus.acl miniserv.conf miniserv.users)
(cd "$config_dir_eu"; %{__chmod} 644 cpplus.acl miniserv.conf miniserv.users)

# start webserver
/sbin/chkconfig --add %{name}
# no start on boot
#if [ "$1" = "1" ]; then
#	/sbin/service %{name} start &>/dev/null || :
#fi
#$config_dir/start >/dev/null 2>&1

# preuninstall section
%preun
# execute this only if we are NOT doing an upgrade
if [ "$1" = "0" ]; then
	wadir=%{product_dir}
	config_dir=%{config_dir}
	var_dir=%{var_dir}
	# stopping service if it's running
	if [ -f /var/lock/subsys/%{name} ]; then
		%{services_dir}/%{name} stop &>/dev/null || :
	fi
	/sbin/chkconfig --del %{name}
	(cd "$wadir" ; WEBMIN_CONFIG=$config_dir WEBMIN_VAR=$var_dir LANG= "$wadir/run-uninstalls.pl" >/dev/null 2>&1)
fi

%postun
# execute this only if we are doing an upgrade
if [ "$1" = "1" ]; then
	if [ -f /var/lock/subsys/%{name} ]; then
		# restarting service if it's running
		%{services_dir}/%{name} restart &>/dev/null || :
	fi
fi

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%files -f %{_tmppath}/product.filelist
%defattr(-,root,root,0755)

%changelog
* Mon May 14 2007 Vadim Lvovsky <vadim[at]psoft[dot]od[dot]ua> - 3.4.1-1tr
- extended Mail Server configuration for Trustix Security Linux-3x;
- added Xinha HTML editor for composing email in the Read Mail module and editing .html pages in the File Manager module
- added new format's support of Clam AntiVirus configuration file (ver.0.90.2)
- optimizations to speed up getting the hostname and Postfix config settings 
- added tabs to reduce the size of main pages in the CP+ Configuration, Apache Webserver and Backup Configuration Files modules
- when installing a Perl module from CPAN and it already exists in an operating system package (APT or YUM), use that instead
- allowed views are now enforced when adding multiple zones from a batch file in the BIND DNS Server
- added fields for editing the number of login processes and UIDL format in the Dovecot IMAP/POP3 Server
- added Read Mail module config option to enable disk cache for listing Maildir files
- added SSH Server module config option to set the SSH server version manually
- added CP+ Configuration module config option to write CP+ actions to syslog 
- now Enduser can edit Read Mail module's interface options
- added a message to the Filter Mail module's main page to detect system-level mail aliases that would forward email to the user to a different destination 
- fixed configure IP Access Control in the CP+ Configuration module
- fixed Upgrade CP+ form's interface
- fixed Add row form in the PostgreSQL Database Server module
- fixed getting path to the log file for VSFTPd server 

* Thu Mar 20 2007 Vadim Lvovsky <vadim[at]psoft[dot]od[dot]ua> - 3.4-1tr
- added the PHP Configuration module for managing php.ini
- added the Filter Mail module, which provides a simpler interface to Procmail for Enduser UI
- added automatic installation/configuration of system services, provided by apt-get updater and CP+ modules for Debian Linux
- added Mail Server automatic installation/configuration for Trustix Security Linux-3x
- extended DNS Server configuration, working configuration of the BIND is based on the OS and CP+ module configuration
- added Read Mail module configuration into Mail Server configuration
- restructured Configure Server module config
- added check of incorrect Configure Server module configuration
- added description of servers on the configuration start page
- in case of adding zone inside view (the zone uses input) it will be used included file (if it was defined in configuration of BIND module)
- added support work with DNS zone which used included file in the Domain Owner UI
- now, if there is no response from the server licences, CP+ is not blocked within two days
- added new option to create zone in view of the BIND module: in the included file
- extended Cyrus-SASL module interface
- added Debian configuration files for Cyrus SASL, Vsftpd and Courier IMAP modules
- added support for comments and improved logging in the Shorewall module
- the File Manager now automatic detects HTML files and launches the correct editor
- added search form in the MySQL and PostgreSQL modules: it appears if there are too many tables or databases to display
- added checkboxes for deleting multiple objects at once in the Protected Web Directories, SysV Init Configuration and PPTP VPN Server modules
- added a popup window for tracking file uploads in the File Manager, Software Packages and Upload and Download> modules
- the CP+ Actions Log module can now rollback selected files changed by an action, rather than all of them
- when a large file is uploaded, it is no longer read into memory by miniserv.pl
- added tabs to the Compose Email page in the Enduser UI, to allow bigger To:/Cc: fields
- added a popup window for tracking file uploads in the File Manager and Read Mail modules in the Enduser UI
- fixed getting maildir files in the Read Mail modules
- fixed java script errors in the Read Mail module in the Enduser UI
- fixed stop service error in the Proftpd module
- fixed dual display the list of Perl-modules in the Cpan module
- fixed checking configuration error in the Courier Imap module

* Thu Feb 1 2007 Vadim Lvovsky <vadim[at]psoft[dot]od[dot]ua> - 3.3-1tr
- added possibility to add Endusers (WEB/FTP users) without  enabled FTP setup and configuration
- added support of IPv6 addresses in the Apache Webserver and Extended Internet Services modules
- MySQL module improvements: added support of gzip/bzip2 compression for backups, added possibility to select character set for new databases
- Configure Server module improvements: 
- added added generating of administrator's password and setting of password authentication mode for allowed hosts at the moment of automatic configuration of PostgreSQL Server
- added Mailman enable configuration option to the module configuration
- into the Disk and Network Filesystems module added support of: HFS and FATX filesystems, partitions specified using the UUID notation in /etc/fstab
- into the File Manager module added: access control options for the Info window, possibility to allow extraction of ZIP files on the server
- added checkboxes and buttons for mass deletion in the Cron module
- added locking and logging option for all actions to the Postfix module
- added support of Ubuntu Linux (which has not /etc/inittab file) in the Bootup and Shutdown module
- extended website's information about domain users in the Owner interface
- removed Change domain name icons for domain (website) in the Owner interface
- possibility to set enduser quota more when max available disk space for domain in the Owner interface
- added possibility to change  Preferences section for MySQL and PostgreSQL modules in the Enduser interface
- added direct download option of files from the search results window in the File Manager module in the Enduser interface
- in the PostgreSQL Database Server module fixed: work with Granted Privileges, changing of administration login, login in the unix user mode
- fixed restoring of domain (website) with postgresql databases
- fixed DNS Server automatically configuration for Fedora Core 6
- disabled Configure Server icon in the Server Management section for non-supported system;<br>
- fixed Mailman module start/restart functions
- fixed information panel error in the Enduser interface for CentOs-3x
- fixed login to MySQL and PostgreSQL in the Enduser interface

* Thu Dec 14 2006 Vadim Lvovsky <vadim[at]psoft[dot]od[dot]ua> - 3.2.1-1tr
- added Courier-Imap module's interface
- changed categories for some modules
- added option 'Deliver to my mailbox' for AutoResponder in the Enduser interface
- fixed removing of website (domain) with two and more subdomains
- fixed restoring of IP-based website (domain)
- fixed adding of FTP users
- fixed view of subdomain's quotas
- fixed managing of  website (domain) with unlimited disk quota
- fixed interface error in the info panel of Domain Owner with subdomains
- fixed upgrading CP+ from 2.x version
- fixed wrong Confmaster start for non-supported systems
- fixed Mail Server configuration in the Confmaster module
- fixed Mailman mailing lists mangment for websites (domains)
- fixed Domain Owners' access to configuration of CPAN module, upgrade and uninstallation of  Perl modules
- fixed EndUser CP+ confuguration module interface
- fixed Cron jobs' listing
- fixed execute batch file for managing system users
- fixed Enduser's Change Details option
- fixed interface error in the Enduser Webmail module 

* Thu Oct 15 2006 Oleg Muntyan <oleg[at]psoft[dot]od[dot]ua> - 3.2.0-1tr
- new type of license
- module for PHP plugins (SquirrelMail, phpMyAdmin)
- module for Mailman
- configure Mail Server with mailman
- new feature mailman
- add showing quantity of databases in Manage Websites and in owner interface
- fixed upgrading CP+ from 2.x version
- fixed saving unlimited disk quota in the Manage Websites
- fixed Software module for FreeBSD
- fixed Cyrus SASL module interface
- fixed editing domain names for domain Owner
- fixed VsFTPD templete error in the Manage Websites module
- added changing root user password in the MySQL configuration
- added upgrade and reconfigure servers in Configure Server module 
- added a page in MySQL module for showing database connections
- added a page in MySQL module for listing MySQL server variables, with the ability to edit system variables
- column headings in the Table Data page in databases modules can be clicked to sort the data by that column
- mail aliases have human-readable descriptions associated with them
- added some improvements in File Manager module (the ability to extract tar.bz2 files, history button next to the field for entering a directory to show, for quickly navigating to recently entered paths, text fields to the file info window showing the total size, number of sub-files and number of sub-directories in a directory)

* Thu Jun 29 2006 Oleg Muntyan <oleg[at]psoft[dot]od[dot]ua> - 3.1.1-1tr
- Fixed CP+ service name.
- Fixed limit of databases for subdomain.
- Fixed view of EndUsers' limit in the left panel of owner's interface.
- Added possibility to choose directory in Upload and Download module for EndUser.
- Fixed sending wrong email to ftpuser at the moment of creation of EndUser.
- Fixed view of databases list in Manage Databases section.
- Provided access to File Manager module for EndUser.
					      
* Mon Jun 05 2006 Oleg Muntyan <oleg[at]psoft[dot]od[dot]ua> - 3.1-1tr
- Syslog-NG module to configure syslog replacement that is now standard on SuSE Linux;
- MIME Type Programs module for editing the /etc/mailcap file.
- Added an ACL option to allow a CP+ user to apply the BIND configuration, but not stop or start the BIND DNS server.
- Added an option on the SSL Encryption page to prevent the use of SSL version 2 into CP+ Configuration and End User Configuration.
- Added a new page for editing MySQL server settings in the [mysqld] section of the my.cnf file.
- Added an option on the User SSH Key Setup page for selecting the key type to create. Added support for systems that don't have an SSH server PID file (like OS X).
- Multiple Cron jobs can be enabled or disabled at once, in a similar way to many can be deleted.
- Fixed showing group quota warning message on CP+ core when quotas are disabled.
- Added support for the FreeBSD 5.x rc.d bootup scripts directory.
- Added the ability to specify extra directives to be added to .htaccess files.
- Added support for editing the IPv6 host addresses file on Solaris (/etc/inet/ipnodes).
- Into Squid Analysis Report Generator added a Module Config option to prevent the CP+ header and footer from being added when viewing a SARG report.
- Added support for the SNMP_Session Perl module for sending SNMP traps, as an alternative to Net::SNMP.
- Added an access control option into Users and Groups module to prevent the renaming of users.
																	    
* Sat May 06 2006 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 3.0.3-1tr
- Fixed error of losing named.conf file while reconfiguring DNS Server in the Configure Server module
- Fixed getting trial license

* Thu May 04 2006 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 3.0.2-1tr
- Fixed getting of FTP traffic for domain owner and any of End Users with FTP access in the Website Management module.
- Fixed adding of NameVirtualHost directive into Apache config file while creating website on shared IP in the Website Management module.
- Fixed error of switching between CP+ modes on the Main page in the domain owner interface.
- Fixed managing of DNS records for admin interface in the BIND DNS Server module.
- Fixed redirecting between pages in the Save Zone page in the BIND DNS Server module.
- Fixed view of xferlog_file option editor in the VSFTPd module.
- Fixed footer link in the Import Existing Website page.

* Wed Mar 29 2006 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 3.0.1-1tr
- Fixed owner interface, when websites limits had been set to 0
- Fixed confirmation before deleting DNS records in the owner interface
- Changed email template for new domain without databases
- Fixed restoring of disabled domains. Now its features are disabling while restoring
- Fixed a wrong redirect from Edit Apache Directives pages in the owner UI
- Fixed deleting domains with End Users without samba feature
- Added message if upgrade list is empty into the SWUP configuration module
- Added parsing of End User's Real Name. Now admin can see and change only End User's Real Name
- Fixed changing End User's Real Name in the Edit End User page
- Added description for start\restart\stop buttons and footer in the ClamAV Configuration module
- Fixed checking a password in the Edit End User page
- Added regenerating a virtual table into Mail Server configuration in the Configure Server module
- Fixed creating slave zones issue in the BIND DNS Server module
- Added missed text on the List Packages in SWUP Configuration module

* Tue Mar 14 2006 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 3.0-1tr
- This version contains many major additions, improvements and feature enhancements (see detailed changes log: http://cpplus.info/feature_30.html).

* Wed Nov 30 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5.5-1tr
- Fixed a possible security flaw caused by a bug in Perl.

* Wed Jul 20 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5.4-1tr
- Added automatic configuration of SpamAssassin and Procmail Mail Filters in Configure Servers module.
- Fixed view of Jakarta-Tomcat Configuration index page.
- Category's Other modules are displayed on System Administration page.
- Fixed output of messages on Samba Windows File Sharing index page.
- Fixed PostgreSQL Database Server module in some configurations.
- Fixed default configuration of SpamAssassin Mail Filter and BIND DNS Server for Trustix OS modules.
- Now %{_sysconfdir}/pam.d/%{name} and %{_sysconfdir}/sysconfig/%{name} files are not marked as configs.

* Tue Jul 05 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5.3-1tr
- Fixed checking of Jakarta-Tomcat module configuration
- Fixed updating of cron jobs
- Fixed index page's showing error in the Webalizer module

* Thu Jun 30 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5.2-1tr
- Changed view of information about disk space/bandwidth on FreeVPS servers. Now the unit of measure is megabyte.
- To allow EndUser to redefine certain configuration modules' parameters in EndUser CP+ interface, there were changed access rights to CP+ configuration files' directory.
- Fixed CP+ upgrade of configuration files and access rights for users at installing CP+ from rpm package.
- Fixed detecting TrustixOS in the Upgrade CP+ and Upgrade Packages features.
- Fixed CP+ upgrade from rpm.

* Mon Jun 27 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5.1-1tr
- Fixed upgrade of CP+ 2.5.
- Fixed the problem with rejection of access to Home module in upgrade CP+ 1.x.
- Fixed install of new Perl packages from cpan.org in Perl Modules.
- Minor fixes in interfaces of CP+ Configuration and End User CP+ Configuration modules.
- Added images for Squid Analysis Report Generator module.
- In Configure Servers module fixed automatic configuration of servers for Red Hat EL-4.x and CentOS-4.x operating systems.

* Wed Jun 15 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.5-1tr
- Greatly improved speed of the CP+ UI.
- Added new module Configure Servers for automatic installation and configuration of Web, Mail, DNS, MySQL, PostgreSQL servers and Quota Tools.
- Selection of mail folder for domain-owner and endusers is added in Webmail.
- Corrected installation of license key.
- End users can be correctly deleted of End Users' List page.
- Fixed support for DNS Management page in Trustix OS.
- Edit of database limits on the Edit Website page is added.
- If ProFTPd setup and configuration feature is disabled, the FTP User's shell check is ignored.
- Fixed check of website's database limits at adding of new database.

* Fri Apr 22 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.4.1-1tr
- fixes creating of the script for starting CP+ and EndUser CP+ Servers
- changed the interface of the main page of software module
- added detecting of Trustix Secure Linux 3.0
- added new Cyrus SASL Configuration module which can be used to edit cyrus-sasl configuration files and to provide ability to start saslauthd authentication and authorization service
- fixed a path to the EndUser CP+ Server configuration files in the EndUser CP+ Configuration module
- fixed Unix User and Groups module configuration file for Trustix OS. Now new unix-user will be created in the /home/users directory instead of /home
- fixed installation of root directory of the server at EndUser CP+ Server start up

* Tue Apr 19 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.4-1tr
- adds support for multiple MySQL and PostgreSQL databases per user, as well as vpopmail support
- some numerous bugfixes and other small improvements for Websites

* Thu Mar 24 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.3-1tr
- fixes adding empty restart and stop scripts in the root directory while rpm is building.
- adds updating miniserv.conf with new root directory and mime types file when rpm is upgrading.
- a lot of additions and improvements and some bugfixes.

* Mon Mar 07 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.2.2-1tr
- Add the File Locking page which can be used to limit CP+'s .lock file creation to certain directories or disable it altogether.
- Correct operation with quotas by webservers, default and create websevers with unlimited quotas.
- Corrects a conclusion of the information about quotas End Usera in End User the interface.
- Some images for Samba Windows File Sharing module were replaced.

* Tue Mar 04 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.2.1-2tr
- fix option in EndUser CP+ configuration which defines file with users list

* Tue Mar 01 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.2.1-1tr
- fix website quotas when blocks are used
- fix EndUser CP+ interface

* Wed Feb 23 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.2-1tr
- add setting a password of unixuser root for CP+ admin account when CP+ starts at first time
- turn off starting cpplus service when rpm is installing
- add chkconfig to require list
- add deleting cpplus service when CP+ is uninstalling
- a lot of additions and improvements and provides protection against brute-force password guessing attacks

* Mon Feb 14 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.1.1-1tr
- fix creating of name-based websites

* Thu Feb 10 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.1.0.1-1tr
- add replacement for start, stop and restart scripts
- correct identification of FreeBSD 5.3
- CP+ is correctly started on FreeBSD servers now
- versioning number system is modified

* Tue Feb 08 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.03-3tr
- Fixed warnings
- Added setting up root password for admin account

* Thu Feb 03 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.03-2tr
- Change section order
- Fixed cleaning up files
- Fixed duplicating files
- Fixed getting file list

* Tue Jan 25 2005 Vladimir Kurnavenkov <vkurn[at]psoft[dot]net> - 2.03-1tr
- Initial release

